<template>
  <q-card
    flat
    class="q-pa-lg q-mr-md rounded-borders-10 cursor-pointer"
    style="max-width: 100%"
  >
    <div class="row">
      <div class="q-mr-lg">
        <custom-avatar
          :photoUrl="job.user.profile_picture_url"
          :name="job.company_name"
          userType="jobseeker"
          fontSize="35px"
          size="100px"
          :circle="false"
          shadow="shadow-5"
        />
      </div>
      <div class="col q-py-lg" @click="onClickApplyNow(job.id)">
        <p class="title-headline">{{ job.job_title }}</p>
        <p class="title-8">{{ job.company_name }}</p>
      </div>
    </div>

    <div class="row" :class="{ column: $q.screen.lt.lg }">
      <div class="col q-my-auto">
        <span class="footer text-grey-7"
          >POSTED {{ getDaysPosted(job.updated_at) }} DAYS AGO</span
        >
      </div>
      <div class="col" align="right" :class="{ 'q-mt-md': $q.screen.lt.md }">
        <q-btn
          id="apply"
          unelevated
          class="btn-md text-white q-mr-sm"
          :loading="loading"
          :disable="job.is_applied === true"
          :color="job.is_applied === true ? 'light-blue-1' : 'light-blue-10'"
          :text-color="job.is_applied === true ? 'light-blue-10' : 'white'"
          :label="job.is_applied === true ? 'APPLIED' : 'APPLY NOW'"
          @click="onClickApplyNow(job.id)"
          :style="{
            width: $q.screen.lt.sm ? 'calc(100% - 50px ) !important;' : 'auto',
          }"
        />

        <q-btn
          unelevated
          class="btn-md"
          :class="
            job.is_saved === true ? 'btn-save filled' : 'btn-save outlined'
          "
          :text-color="job.is_saved === true ? 'white' : 'primary'"
          :icon="
            job.is_saved === true ? 'eva-bookmark' : 'eva-bookmark-outline'
          "
          @click="onClickSaveJob(job.id, job.is_saved)"
        />
      </div>
    </div>
  </q-card>

  <!-- DIALOG: APPLY NOW -->
  <q-dialog
    v-model="showApplyNowDialog"
    persistent
    @hide="showApplyNowDialog === false"
  >
    <q-card
      flat
      class="card-job rounded-borders-10"
      style="width: 1200px; max-width: 100%"
    >
      <q-card-section class="row items-center q-pa-none">
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-form @submit="confirmApplyNow(jobStore.job.id)">
        <q-card-section>
          <div class="row">
            <div class="col-2" style="width: 80px">
              <div class="q-mr-lg">
                <custom-avatar
                  :photoUrl="jobStore.job.user.profile_picture_url"
                  :name="jobStore.job.company_name"
                  userType="jobseeker"
                  fontSize="17px"
                  size="60px"
                  :circle="false"
                  shadow="shadow-5"
                />
              </div>
            </div>

            <div class="col q-py-xs">
              <p class="title-headline q-mb-sm">
                {{ jobStore.job.job_title }}
              </p>
              <p class="title-6">{{ jobStore.job.company_name }}</p>
            </div>

            <div :class="$q.screen.lt.sm ? 'col-12' : 'col-3'">
              <div
                class="salary-container rounded-borders-10 bg-grey-2 text-center"
                style="width: 100%; min-width: 197px; position: relative"
              >
                <div class="salary">
                  <span class="text-dark">
                    {{
                      jobStore.job.salary_from || jobStore.job.salary_to
                        ? "₱ "
                        : "salary range not available"
                    }}
                  </span>

                  <strong class="text-dark">
                    {{
                      jobStore.job.salary_from || jobStore.job.salary_to
                        ? formatSalary(jobStore.job.salary_from) +
                          " - " +
                          formatSalary(jobStore.job.salary_to)
                        : ""
                    }}
                  </strong>

                  <span>
                    {{
                      jobStore.job.salary_from || jobStore.job.salary_to
                        ? " / mo"
                        : ""
                    }}
                  </span>
                </div>
              </div>
            </div>
          </div>
        </q-card-section>

        <q-card-section
          v-show="
            jobStore.job.full_time === true ||
            jobStore.job.part_time === true ||
            jobStore.job.freelance_or_contract === true ||
            jobStore.job.entry_level === true ||
            jobStore.job.intermediate === true ||
            jobStore.job.expert === true ||
            jobStore.job.on_site === true ||
            jobStore.job.remote === true ||
            jobStore.job.hybrid === true ||
            jobStore.job.years_of_experience >= 1 ||
            jobStore.job.vacancy_number >= 1
          "
        >
          <div class="row">
            <div class="col q-gutter-md">
              <!-- TAGS FOR JOB TYPE -->
              <q-badge
                v-if="jobStore.job.full_time === true"
                class="badge q-mt-sm"
                color="white"
                label="FULL-TIME"
              />
              <q-badge
                v-if="jobStore.job.part_time === true"
                class="badge q-mt-sm"
                color="white"
                label="PART-TIME"
              />
              <q-badge
                v-if="jobStore.job.freelance_or_contract === true"
                class="badge q-mt-sm"
                color="white"
                label="FREELANCE/CONTRACT"
              />

              <!-- TAGS FOR EXPERIENCE LEVEL -->
              <q-badge
                v-if="jobStore.job.entry_level === true"
                class="badge q-mt-sm"
                color="white"
                label="ENTRY LEVEL"
              />
              <q-badge
                v-if="jobStore.job.intermediate === true"
                class="badge q-mt-sm"
                color="white"
                label="INTERMEDIATE"
              />
              <q-badge
                v-if="jobStore.job.expert === true"
                class="badge q-mt-sm"
                color="white"
                label="EXPERT"
              />

              <!-- TAGS FOR OTHERS -->
              <q-badge
                v-if="jobStore.job.on_site === true"
                class="badge q-mt-sm"
                color="white"
                label="ON-SITE"
              />
              <q-badge
                v-if="jobStore.job.remote === true"
                class="badge q-mt-sm"
                color="white"
                label="REMOTE"
              />
              <q-badge
                v-if="jobStore.job.hybrid === true"
                class="badge q-mt-sm"
                color="white"
                label="HYBRID"
              />

              <q-badge
                v-if="jobStore.job.years_of_experience >= 1"
                class="badge q-mt-sm"
                color="white"
              >
                {{
                  jobStore.job.years_of_experience === 1
                    ? jobStore.job.years_of_experience + " YEAR EXPERIENCE"
                    : jobStore.job.years_of_experience + " YEARS EXPERIENCE"
                }}
              </q-badge>
              <q-badge
                v-if="jobStore.job.vacancy_number >= 1"
                class="badge q-mt-sm"
                color="white"
              >
                {{
                  jobStore.job.vacancy_number === 1
                    ? jobStore.job.vacancy_number + " VACANCY"
                    : jobStore.job.vacancy_number + " VACANCIES"
                }}
              </q-badge>
            </div>
          </div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div
            class="row q-mt-lg"
            :class="$q.screen.lt.sm ? 'column reverse' : ''"
          >
            <div :class="$q.screen.lt.sm ? 'col-12' : 'col-6'">
              <span
                class="title-4 text-dark"
                v-html="jobStore.job.job_description"
              >
              </span>
            </div>

            <div class="col-1" v-if="!$q.screen.lt.sm"></div>

            <div :class="$q.screen.lt.sm ? 'col-12 q-mb-xl' : 'col'">
              <div class="q-mb-lg" v-if="jobStore.job.is_applied === true">
                <label class="text-caption text-weight-bold text-grey-7"
                  >STATUS</label
                >
                <div class="row q-my-sm">
                  <div class="col">
                    <div
                      style="
                        height: 40px;
                        display: flex;
                        align-items: center;
                        padding: 10px;
                        font-weight: 800;
                        font-size: 15px;
                        border-radius: 10px;
                      "
                      :style="{
                        color: `${statusColor(form.application_status)}`,
                        background: `${statusBackgroundColor(
                          form.application_status
                        )}`,
                      }"
                    >
                      {{ form.application_status }}
                    </div>
                  </div>
                </div>
              </div>

              <div>
                <label class="text-caption text-weight-bold text-grey-7"
                  >CV / RESUME</label
                >
                <q-file
                  dense
                  outlined
                  v-model="form.cv_or_resume"
                  max-file-size="5242880"
                  class="q-my-sm"
                  :rules="[validations.requiredField]"
                  :filter="checkFileType"
                  :label="
                    form.cv_or_resume_path !== null
                      ? form.cv_or_resume_path
                      : 'Selected File'
                  "
                  :disable="form.cv_or_resume_path !== null"
                  @rejected="onRejected(form.cv_or_resume)"
                  @update:model-value="onRejected(form.cv_or_resume)"
                  @click="toggleFileNameVisibility"
                  @change="onFileChange"
                >
                  <template v-slot:prepend>
                    <q-icon name="eva-attach-outline" />
                  </template>
                </q-file>
                <p id="error" class="q-field_messages text-negative">
                  {{ errorMessage }}
                </p>
              </div>

              <div>
                <label class="text-caption text-weight-bold text-grey-7">
                  COVER LETTER (OPTIONAL)
                </label>
                <q-editor
                  class="q-my-sm"
                  v-model="form.cover_letter"
                  min-height="10rem"
                  min-width="100%"
                  :dense="$q.screen.lt.md"
                  :toolbar="[]"
                  :disable="form.cover_letter"
                />

                <!-- :toolbar="[
                  ['bold', 'italic', 'strike', 'underline'],
                  ['link'],
                  [
                    {
                      label: $q.lang.editor.align,
                      icon: $q.iconSet.editor.align,
                      fixedLabel: true,
                      list: 'only-icons',
                      options: ['left', 'center', 'right', 'justify'],
                    },
                  ],
                  ['unordered', 'ordered', 'outdent', 'indent'],
                ]" -->
              </div>

              <div class="row q-mt-lg">
                <div
                  class="q-mr-xl"
                  :class="$q.screen.lt.md ? 'col-12' : 'col'"
                >
                  <label class="text-caption text-weight-bold text-grey-7">
                    INTERVIEW AVAILABILITY
                  </label>
                  <q-btn-group
                    unelevated
                    class="my-custom-toggle q-my-sm"
                    style="min-width: 380px !important"
                  >
                    <q-btn
                      v-for="(option, index) in form.day_options"
                      :key="index"
                      :color="option.color"
                      :label="option.label"
                      :text-color="option.textColor"
                      @click="setDaysAvailable(option, index)"
                    ></q-btn>
                  </q-btn-group>
                </div>

                <div
                  class="q-ml-xl q-my-sm"
                  :class="$q.screen.lt.md ? 'col-12 q-mt-sm' : 'col q-ml-xl'"
                >
                  <label v-if="!$q.screen.lt.md" class="title-xsmall text-white"
                    >.</label
                  >
                  <q-btn-group
                    unelevated
                    class="my-custom-toggle"
                    style="min-width: 100px !important"
                  >
                    <q-btn
                      v-for="(option, index) in form.time_options"
                      :key="index"
                      :color="option.color"
                      :label="option.label"
                      :text-color="option.textColor"
                      @click="setTimeAvailable(option, index)"
                    ></q-btn>
                  </q-btn-group>
                </div>
              </div>
            </div>
          </div>
        </q-card-section>

        <div class="row q-pa-md q-mt-xl">
          <div class="q-mt-md" :class="$q.screen.lt.sm ? 'col-12' : 'col'">
            <span class="title-xsmall text-grey" style="color: #707070"
              >POSTED
            </span>
            <span
              class="title-xsmall text-weight-bold text-grey-7"
              style="color: #707070"
              >{{ getDaysPosted(jobStore.job.updated_at) }} DAYS AGO</span
            >
          </div>

          <div
            align="right"
            :class="
              $q.screen.lt.sm
                ? 'col-12 flex items-center justify-between q-mt-md'
                : 'col'
            "
          >
            <q-btn
              id="apply"
              unelevated
              type="submit"
              class="btn-md text-white q-mr-sm"
              :style="{
                width: $q.screen.lt.sm
                  ? 'calc(100% - 55px) !important'
                  : 'auto',
              }"
              :disable="jobStore.job.is_applied === true"
              :color="
                jobStore.job.is_applied === true
                  ? 'light-blue-1'
                  : 'light-blue-10'
              "
              :text-color="
                jobStore.job.is_applied === true ? 'light-blue-10' : 'white'
              "
              :label="
                jobStore.job.is_applied === true ? 'APPLIED' : 'APPLY NOW'
              "
              :loading="loading"
            />

            <q-btn
              id="save"
              unelevated
              :class="
                jobStore.job.is_saved === true
                  ? 'btn-save filled'
                  : 'btn-save outlined'
              "
              :text-color="jobStore.job.is_saved === true ? 'white' : 'primary'"
              :icon="
                jobStore.job.is_saved === true
                  ? 'eva-bookmark'
                  : 'eva-bookmark-outline'
              "
              @click="onClickSaveJob(jobStore.job.id, jobStore.job.is_saved)"
            />
          </div>
        </div>
      </q-form>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive } from "vue";
import { requiredField } from "src/hooks/validations";
import { useJob } from "../../../store/job";
import { useApplication } from "src/modules/messages/store/application";
// import { LocalStorage } from "quasar";
import useApplicationHook from "../../../hooks/applicationHook";
import CustomAvatar from "src/components/CustomAvatar.vue";
import { useUser } from "src/layouts/portals/store/user";

export default defineComponent({
  components: { CustomAvatar },
  props: {
    job: {
      type: Array,
      default: () => {
        return [];
      },
    },
  },
  setup(props) {
    const userStore = useUser();
    const jobStore = useJob();
    const { getJobs, getJob, getSavedJobs } = jobStore;

    const applicationStore = useApplication();
    const { getApplications } = applicationStore;

    const { loading, doApplyJob, doSaveJob, doUnsaveJob } =
      useApplicationHook();

    const showApplyNowDialog = ref(false);
    const form = reactive({
      application_status: null,
      job_post_id: null,
      cover_letter: null,
      cv_or_resume: null,
      cv_or_resume_path: null,
      day_options: [
        {
          label: "Mon",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Tue",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Wed",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Thu",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Fri",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
      ],
      time_options: [
        {
          label: "AM",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "PM",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
      ],
    });

    const onClickApplyNow = async (id) => {
      form.cover_letter = null;
      await getJob(id);

      fetchApplicationData(id);
      // form.cv_or_resume_path = LocalStorage.getItem("auth").cv_or_resume;
      form.cv_or_resume_path = userStore.userDetails.cv_or_resume;
      showApplyNowDialog.value = true;
    };

    const fetchApplicationData = (job_id) => {
      for (let x = 0; x < applicationStore.applications.length; x++) {
        const application = applicationStore.applications[x];

        if (application.job_post_id === job_id) {
          form.application_status = application.application_status.name;
          form.cover_letter = application.cover_letter;
          form.day_options = [
            {
              label: "Mon",
              color: application.monday === true ? "primary" : "grey-2",
              textColor: application.monday === true ? "white" : "dark",
              value: application.monday,
            },
            {
              label: "Tue",
              color: application.tuesday === true ? "primary" : "grey-2",
              textColor: application.tuesday === true ? "white" : "dark",
              value: application.tuesday,
            },
            {
              label: "Wed",
              color: application.wednesday === true ? "primary" : "grey-2",
              textColor: application.wednesday === true ? "white" : "dark",
              value: application.wednesday,
            },
            {
              label: "Thu",
              color: application.thursday === true ? "primary" : "grey-2",
              textColor: application.thursday === true ? "white" : "dark",
              value: application.thursday,
            },
            {
              label: "Fri",
              color: application.friday === true ? "primary" : "grey-2",
              textColor: application.friday === true ? "white" : "dark",
              value: application.friday,
            },
          ];
          form.time_options = [
            {
              label: "AM",
              color: application.am === true ? "primary" : "grey-2",
              textColor: application.am === true ? "white" : "dark",
              value: application.am,
            },
            {
              label: "PM",
              color: application.pm === true ? "primary" : "grey-2",
              textColor: application.pm === true ? "white" : "dark",
              value: application.pm,
            },
          ];
        }
      }
    };

    const toggleFileNameVisibility = () => {
      fileNameVisible.value = !fileNameVisible.value;
    };

    const onFileChange = (newFile) => {
      form.cv_or_resume = newFile;
    };

    const statusColor = (status) => {
      switch (status) {
        case "Pending":
          return "#9E9E9E";
          break;
        case "1st Interview Pending":
          return "#FF9800";
          break;
        case "1st Interview Confirmed":
          return "#FFC107";
          break;
        case "2nd Interview Pending":
          return "#06A9F4";
          break;
        case "2nd Interview Confirmed":
          return "#009688";
          break;
        case "Hired":
          return "#4CAF50";
          break;
        case "Rejected":
          return "#F44336";
          break;
        default:
          return "#F0F0F0";
          break;
      }
    };

    const statusBackgroundColor = (status) => {
      switch (status) {
        case "Pending":
          return "#F5F5F5";
          break;
        case "1st Interview Pending":
          return "#FFF3E0";
          break;
        case "1st Interview Confirmed":
          return "#FFF8E1";
          break;
        case "2nd Interview Pending":
          return "#E1F5FE";
          break;
        case "2nd Interview Confirmed":
          return "#E0F2F1";
          break;
        case "Hired":
          return "#E8F5E9";
          break;
        case "Rejected":
          return "#FFEBEE";
          break;
        default:
          return "#F0F0F0";
          break;
      }
    };

    const setDaysAvailable = (option, index) => {
      if (option.value === false) {
        form.day_options[index].color = "primary";
        form.day_options[index].textColor = "white";
        form.day_options[index].value = true;
      } else {
        form.day_options[index].color = "grey-2";
        form.day_options[index].textColor = "dark";
        form.day_options[index].value = false;
      }
    };

    const setTimeAvailable = (option, index) => {
      if (option.value === false) {
        form.time_options[index].color = "primary";
        form.time_options[index].textColor = "white";
        form.time_options[index].value = true;
      } else {
        form.time_options[index].color = "grey-2";
        form.time_options[index].textColor = "primary";
        form.time_options[index].value = false;
      }
    };

    const getDaysPosted = (date) => {
      let currentDate = new Date();
      let startDate = new Date(date);

      var difference = Math.abs(currentDate - startDate);
      var numberOfDays = difference / (1000 * 3600 * 24);
      return Math.round(numberOfDays);
    };

    const formatSalary = (salary) => {
      return salary.toLocaleString();
    };

    const confirmApplyNow = (id) => {
      form.job_post_id = id;
      loading.value = true;

      const formData = new FormData();

      formData.append("job_post_id", form.job_post_id);
      if (form.cv_or_resume === null) {
        formData.append("cv_or_resume_path", form.cv_or_resume_path);
      } else {
        formData.append("cv_or_resume", form.cv_or_resume);
      }

      if (form.cover_letter !== null) {
        formData.append("cover_letter", form.cover_letter);
      }
      formData.append("monday", form.day_options[0].value);
      formData.append("tuesday", form.day_options[1].value);
      formData.append("wednesday", form.day_options[2].value);
      formData.append("thursday", form.day_options[3].value);
      formData.append("friday", form.day_options[4].value);
      formData.append("am", form.time_options[0].value);
      formData.append("pm", form.time_options[1].value);

      setTimeout(async () => {
        await doApplyJob(formData);
        await getJobs();
        loading.value = false;

        resetForm();
        showApplyNowDialog.value = false;
      }, 1000);
    };

    const resetForm = () => {
      form.job_post_id = null;
      form.cv_or_resume = null;
      form.cover_letter = null;
      form.day_options = [
        {
          label: "Mon",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Tue",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Wed",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Thu",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "Fri",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
      ];
      form.time_options = [
        {
          label: "AM",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
        {
          label: "PM",
          color: "grey-2",
          textColor: "dark",
          value: false,
        },
      ];
    };

    const onClickSaveJob = (id, is_saved) => {
      if (is_saved === false) {
        doSaveJob(id);
      } else {
        getSavedJobs();
        for (let x = 0; x < jobStore.savedJobs.length; x++) {
          const savedJob = jobStore.savedJobs[x];

          if (id === savedJob.job_post_id) {
            savedJob.is_saved = false;
            doUnsaveJob(savedJob.id);
          }
        }
      }
      getJobs();
    };

    getApplications();

    return {
      form,
      userStore,
      jobStore,
      applicationStore,
      showApplyNowDialog,
      statusColor,
      statusBackgroundColor,
      onClickApplyNow,
      getDaysPosted,
      onClickSaveJob,
      confirmApplyNow,
      formatSalary,
      toggleFileNameVisibility,
      onFileChange,
      setDaysAvailable,
      setTimeAvailable,
      validations: {
        requiredField,
      },
      checkFileType(files) {
        return files.filter(
          (file) =>
            file.type === "application/msword" ||
            file.type ===
              "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
            file.type === "application/pdf" ||
            file.type === "image/png" ||
            file.type === "image/jpeg" ||
            file.type === "image/jpg"
        );
      },
      onRejected(files) {
        for (let x = 0; x < files.length; x++) {
          const file = files[x];

          if (file.failedPropValidation === "max-file-size") {
            isError.value = true;
            errorMessage.value = "File size should not be greater than 5MB";
          } else if (file.failedPropValidation === "filter") {
            isError.value = true;
            errorMessage.value = "The file type uploaded is not supported";
          } else {
            isError.value = false;
            errorMessage.value = "";
          }
        }
      },
    };
  },
});
</script>

<style lang="scss" scoped>
.logo-container {
  width: 100px;
  height: 100px;
  background-color: $brand-1;

  &-small {
    width: 60px !important;
    height: 60px !important;
  }
}
.my-custom-toggle {
  border-radius: 10px;
  height: 40px;
  width: 100%;
  position: relative;
}
.q-editor {
  border-radius: 10px;
  // background: #f5f5f5;
  width: 100%;
}

.salary-container {
  padding: 10px 20px 10px 20px;
}

#apply {
  width: 120px !important;
}

.card-job {
  padding: 30px 30px !important;
}

#apply {
  width: 120px !important;
}
.btn-save {
  width: 41.49px !important;
  height: 35px !important;
  height: 35px !important;
}
.filled {
  background: #5599da !important;
}
.outlined {
  border: 1px solid #5599da !important;
}
</style>
